/*
 * Copyright (c) 1994-1996 by Vixie Enterprises.
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND VIXIE ENTERPRISES DISCLAIMS ALL
 * WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL VIXIE ENTERPRISES BE LIABLE
 * FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
 * OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

/* copy2way - command line interface to copy2way()
 * vix 16may94 [original]
 */

#if !defined(lint) && !defined(codecenter)
static char rcsid[] = "$Id: main.c,v 1.3 1996/05/16 04:48:38 vixie Exp $";
#endif

#include "vixutil.h"
#include <unistd.h>
#include <errno.h>
#include <sysexits.h>

extern char	*sbrk(int incr);

static const char usage[] = "usage:  copy2way s1 s2 bufsiz\n";
static const char nobrk[] = "sbrk failed\n";

main(int argc, char *argv[]) {
	int c, n[3], *s1 = &n[0], *s2 = &n[1], *bufsiz = &n[2];
	char *buf;

	argc--, argv++;
	if (argc != (sizeof n / sizeof n[0]))
		goto usage;
	for (c = 0;  c < argc;  c++)
		if (!str_isnumber(argv[c]))
			goto usage;
		else
			n[c] = atoi(argv[c]);
	buf = sbrk(*bufsiz);
	if ((long)buf == -1 || (long)buf == 0) {
		int save = errno;

		write(STDERR_FILENO, nobrk, sizeof nobrk - 1);
		exit(save);
	}
	if (copy2way(*s1, *s2, buf, *bufsiz) < 0)
		exit(errno);
	exit(EX_OK);
 usage:
	write(STDERR_FILENO, usage, sizeof usage - 1);
	exit(EX_USAGE);
}
