/*
 * Copyright (c) 1994-1996 by Vixie Enterprises.
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND VIXIE ENTERPRISES DISCLAIMS ALL
 * WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL VIXIE ENTERPRISES BE LIABLE
 * FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
 * OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

/* defs.h - definitions for libproxytcp
 * vix 02feb94 [original]
 *
 * $Id: defs.h,v 1.7 1996/05/16 04:48:39 vixie Exp $
 */

#ifndef _PROXYNET_DEFS_H
#define _PROXYNET_DEFS_H

/* don't set this to "1" unless/until the rest of the code gets "reset"
 * primatives and you know that the application will be able to stand
 * having its file layer ripped out from under it (in other words, never).
 */
#define	PROXY_RESET	0

#define	PROXYNET_PORT	555
#define	PROXYNET_SERV	"proxynet"
#define	PROXYNET_TRACE	"PROXYNET_TRACE"

#define	PROXTRC_INIT	0x00000001
#define	PROXTRC_PROTO	0x00000002
#define	PROXTRC_SYSCALL	0x00000004
#define	PROXTRC_LOOKUPS	0x00000008
#define	PROXTRC_FILEDES	0x00000010

#define	SMALL	64
#define	MEDIUM	128
#define	LARGE	256

#define	RETRY_DEFAULT	60	/* one minute */
#define	RETRY_TIMEOUT	600	/* ten minutes */

typedef	int (*proxEachF)(const struct sock *cla,
			    const struct sock *spa,
			    void *pcb,
			    int s);

typedef int (*proxfdEachF)(int s, void *uap);

typedef int (*proxfdEachPF)(void *pcb, int s, void *uap);

enum fdType { fdTnone, fdTaccept, fdTconnect, fdTlisten, fdTerror };

#include "func.h"

#endif /*_PROXYNET_DEFS_H*/
