/*
 * Copyright (c) 1994-1996 by Vixie Enterprises.
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND VIXIE ENTERPRISES DISCLAIMS ALL
 * WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL VIXIE ENTERPRISES BE LIABLE
 * FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
 * OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

/* func.h - proxynet function prototypes
 * vix 30mar94 [added this comment]
 *
 * $Id: func.h,v 1.9 1996/05/16 04:48:39 vixie Exp $
 */

	/* proxy.c */
int		proxyInit __P((void));
int		proxyEachSvcMatch __P((const struct sock *addr,
				       const proxEachF func,
				       int s));
int		proxyProxsrvs_p __P((void *pcb));
int		proxyNamesrvs_p __P((void *pcb));
void *		proxyThisAddr __P((const struct sock *addr));
void *		proxyThisName __P((const char *name));
void *		proxyAddrIsProxy __P((const struct sock *addr));
FILE *		proxyTransaction __P((const void *pcb, const char *req));
void		proxyKeepAlive __P((const void *pcb));
void		proxyTransEach __P((const void *pcb, const char *req));
int		proxyClose __P((void));
void		proxyOverrideNS __P((void *res, void *pp));
#ifdef DEBUG
void		proxyTr __P((unsigned int mask, const char *fmt, ...));
void		proxyLog __P((const char *message, ...));
#else
# define	proxyTr (void)
# define	proxyLog (void)
#endif
	/* service.c */
void		proxsrvInit __P((void));
FILE *		proxsrvOpenF __P((const struct sock *addr));
FILE *		proxsrvOpen __P((const struct sock *addr));
int		proxsrvResp __P((FILE *fp, char *buf, int buflen, int *code));
int		proxsrvCode __P((FILE *fp));
void		proxsrvClose __P((FILE *fp));
void		proxsrvCloseAll __P((void));
	/* file.c */
int		proxfdGet __P((int this));
int		proxfdSet __P((int other, int this));
int		proxfdClr __P((int this));
int		proxfdGetW __P((int this));
int		proxfdSetW __P((int this, int flag));
int		proxfdGetL __P((int this, void *pcb,
				struct sock *cla,
				struct sock *spa));
int		proxfdSetL __P((int this, void *pcb,
				const struct sock *cla,
				const struct sock *spa));
int		proxfdSetT __P((int this, enum fdType type));
enum fdType	proxfdGetT __P((int this));
int		proxfdSetP __P((int this, void *pcb));
int		proxfdEach __P((const proxfdEachF func, void *uap));
int		proxfdEachP __P((int this,
				 const proxfdEachPF func, void *uap));
	/* sys_connect.c */
int		connectSys __P((int s, const struct sockaddr *, int namelen));
int		connect __P((int s, const struct sockaddr *, int namelen));
	/* sys_getpeername.c */
int		getpeernameSys __P((int s, struct sockaddr *, int *namelen));
int		getpeernameProxy __P((int s, struct sock *peer, void *pcb));
int		getpeername __P((int s, struct sockaddr *, int *namelen));
	/* sys_getsockname.c */
int		getsocknameSys __P((int s, struct sockaddr *, int *namelen));
int		getsocknameProxy __P((int s, struct sock *peer, void *pcb));
int		getsockname __P((int s, struct sockaddr *, int *namelen));
	/* sys_listen.c */
int		listenSys __P((int s, int backlog));
int		listenProxy __P((const struct sock *cla,
				 const struct sock *spa,
				 void *pcb, int s));
int		listen __P((int s, int backlog));
	/* sys_close.c */
int		closeSys __P((int fd));
int		close __P((int fd));
	/* sys_accept.c */
int		acceptSys __P((int s, struct sockaddr *, int *namelen));
int		accept __P((int s, struct sockaddr *, int *namelen));
	/* sys_bind.c */
int		bindSys __P((int s, const struct sockaddr *, int len));
int		bind __P((int s, const struct sockaddr *, int len));
	/* resolver.c */
void		proxresInit __P((void));
void		proxresReset __P((void));
