/*
 * Copyright (c) 1994-1996 by Vixie Enterprises.
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND VIXIE ENTERPRISES DISCLAIMS ALL
 * WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL VIXIE ENTERPRISES BE LIABLE
 * FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
 * OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

/* extoa.c - convert exit status to string
 * vixie 27apr94 [split exok() into its own source file]
 * vixie 14mar94 [original]
 */

#if !defined(LINT) && !defined(CODECENTER)
static char rcsid[] = "$Id: extoa.c,v 1.2 1996/05/16 04:48:45 vixie Exp $";
#endif

#include "vixutil.h"
#include <sys/wait.h>
#include <stdio.h>

char *
extoa(int status) {
	static char buf[50];
	char *bufp = buf;

	if (WIFSIGNALED(status)) {
		bufp += sprintf(bufp, "signal %d", WTERMSIG(status));
		if (WCOREDUMP(status))
			bufp += sprintf(bufp, " (core dumped)");
	} else if (WIFEXITED(status)) {
		bufp += sprintf(bufp, "exit %d", WEXITSTATUS(status));
	} else {
		bufp += sprintf(bufp, "status 0x%x", status);
	}
	return (buf);
}
