/*
 * Copyright (c) 1994-1996 by Vixie Enterprises.
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND VIXIE ENTERPRISES DISCLAIMS ALL
 * WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL VIXIE ENTERPRISES BE LIABLE
 * FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
 * OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

/* interval.c - set and test varidic interval timers
 * vix 15feb95 [split out of libproxynet/proxy.c]
 */

#if !defined(LINT) && !defined(CODECENTER)
static char rcsid[] = "$Id: interval.c,v 1.3 1996/05/16 04:48:45 vixie Exp $";
#endif

#include "vixutil.h"


int
interval_overdue_p(register const struct interval *iv) {
	time_t	now = time(NULL);

	return (iv->last == (time_t)0 ||
		iv->retry == (time_t)0 ||
		iv->last + iv->retry < now);
}


void
interval_reset(register struct interval *iv, int retry) {
	iv->last = time(NULL);
	iv->retry = (time_t) retry;
}


