/*
 * Copyright (c) 1994-1996 by Vixie Enterprises.
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND VIXIE ENTERPRISES DISCLAIMS ALL
 * WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL VIXIE ENTERPRISES BE LIABLE
 * FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
 * OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

/* sock_ntox.c - convert internal form to hexdump
 * vixie 27apr94 [moved a lot of things into their own source files]
 * vixie 25feb94 [original]
 */

#if !defined(lint) && !defined(codecenter)
static char rcsid[] = "$Id: sock_ntox.c,v 1.3 1996/05/16 04:48:45 vixie Exp $";
#endif

#include "vixutil.h"

char *
sock_ntox(const struct sock *src) {
	static const char hex[] = "0123456789abcdef";
	static char dst[100];	/* arbitrary size */
	const char *sp = (char *)src;
	unsigned char c;
	char *dp = dst, sep = '\0';
	int len = sizeof(struct sock);

	while (len-- && ((dp - dst) < (sizeof dst - 1))) {
		if (sep != '\0')
			*dp++ = sep;
		else
			sep = ':';
		c = *sp++;
		*dp++ = hex[c>>4];
		*dp++ = hex[c&15];
	}
	*dp = '\0';
	return (dst);
}
