/*
 * Copyright (c) 1994-1996 by Vixie Enterprises.
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND VIXIE ENTERPRISES DISCLAIMS ALL
 * WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL VIXIE ENTERPRISES BE LIABLE
 * FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
 * OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

/* sock_same.c - are two "struct sock"'s the same?
 * vixie 27apr94 [moved a lot of things into their own source files]
 * vixie 25feb94 [original]
 */

#if !defined(lint) && !defined(codecenter)
static char rcsid[] = "$Id: sock_same.c,v 1.2 1996/05/16 04:48:45 vixie Exp $";
#endif

#include "vixutil.h"

/* we use a function for this rather than bcmp() because struct filler bytes
 * won't be initialized to zero on auto (stack) variables.  we could have done
 * this as a macro, but code size is of great concern since we're building a
 * library.
 */
int
sock_same(const struct sock *s1, const struct sock *s2) {
	return (s1->type == s2->type &&
		s1->addr.sa_family == s2->addr.sa_family &&
		s1->addr.sa_len == s2->addr.sa_len &&
		!memcmp(s1->addr.sa_data, s2->addr.sa_data,
			sock_alen(&s1->addr) -
			sizeof s1->addr.sa_family -
			sizeof s1->addr.sa_len));
}
