/*
 * Copyright (c) 1994-1996 by Vixie Enterprises.
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND VIXIE ENTERPRISES DISCLAIMS ALL
 * WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL VIXIE ENTERPRISES BE LIABLE
 * FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
 * OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

/* database.h - proxytcpd's database
 * vix 25feb94 [original]
 *
 * $Id: database.h,v 1.2 1996/05/16 04:48:56 vixie Exp $
 */

#ifndef _DATABASE_H
#define _DATABASE_H

struct prox_tup {
	struct sock	ctl;	/* control session */
	struct sock	cla;	/* client local address */
	struct sock	cpa;	/* client proxy address */
	struct sock	spa;	/* service proxy address */
	struct sock	sra;	/* service remote address */
	int		flags;
#define	PT_NONE		0x0000	/* placeholder */
#define	PT_LISTENER	0x0001	/* else it's a connection */
#define	PT_CLIENT	0x0002	/* modifies PT_LISTENER */
};

struct prox_hnd {
	FILE		*fp;
	pid_t		pid;
	int		disturb;
};

typedef	int (*dbUar)(const char *filename, void *ucp);

void		dbInit(void);
#ifdef XXX
int		dbSvcEnter(const struct sock *svc);
#endif
void		dbForeach(dbUar, void *ucp);
struct prox_tup	*dbFetch(const char *key);
struct prox_hnd	*dbEnter(const struct prox_tup *new);
void		dbRemove(struct prox_hnd *entry);
void		dbClose(struct prox_hnd *entry);
int		dbOpen(const char *filename),
		dbMtime(time_t *mtime);

#ifndef _DATABASE_C
extern char	dbDir[];
#endif

#endif /*_DATABASE_H*/
