/*
 * Copyright (c) 1994-1996 by Vixie Enterprises.
 *
 * Permission to use, copy, modify, and distribute this software for any
 * purpose with or without fee is hereby granted, provided that the above
 * copyright notice and this permission notice appear in all copies.
 *
 * THE SOFTWARE IS PROVIDED "AS IS" AND VIXIE ENTERPRISES DISCLAIMS ALL
 * WARRANTIES WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL VIXIE ENTERPRISES BE LIABLE
 * FOR ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION
 * OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF OR IN
 * CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */

/* defs.h - definitions for proxytcpd
 * vix 24feb94 [original]
 *
 * $Id: defs.h,v 1.3 1996/05/16 04:48:56 vixie Exp $
 */

#ifndef _DEFS_H
#define _DEFS_H

#ifndef _EXT
#define _EXT_HERE
#define _EXT extern
#endif

#define	SMALL	64
#define	MEDIUM	128
#define	LARGE	256

#define	DIRMODE	0770

#include "pathnames.h"
#include "database.h"

typedef int (verbFunc)(int argc, const char * const *argv);

struct verb {
	const char *verb;
	const verbFunc *func;
	const int minarg;
	const int maxarg;
	const char *help;
};

struct lstnDbe {
	ListLink(struct lstnDbe);
	struct prox_hnd	*dbe;
};

	/* Version.c */
extern const char	Version[];

	/* main.c */
extern int		DebugLevel;
extern const char	*ProgramName;
extern char		HostName[];
_EXT ListHeadV(lstnDbeL, struct lstnDbe);
extern void		myExit(int code);

	/* session.c */
void	session(void (signon)(void),
		void (signoff)(void),
		int *quitFlag,
		const struct verb verbs[]),
	eclose(int fd);
int	emit1(int code, char sep, const char *msg, int len),
	emit(int code, const char *msg),
	eemit(const char *msg, int err),
	eemita(const char *msg, int err, const struct sock *sock);

	/* protocol.c */
void	protocol(void);

	/* connect.c */
int	connStream(const struct sock *dest);

	/* listen.c */
int	lstnStream(const struct sock *s_cla,
		   struct sock *s_spa);

#ifndef _EXT_HERE
#undef _EXT_HERE
#undef _EXT
#endif

#endif /*_DEFS_H*/
